// ---------------------------------------------------------------------------
// ,     DS1307 RTC
#include "TWI.h"

#define DS1307 0xD0           //   I2C   DS1307 RTC
#define SECONDS_REGISTER   0x00
#define MINUTES_REGISTER   0x01
#define HOURS_REGISTER     0x02
#define DAYOFWK_REGISTER   0x03
#define DAYS_REGISTER      0x04
#define MONTHS_REGISTER    0x05
#define YEARS_REGISTER     0x06
#define CONTROL_REGISTER   0x07
#define RAM_BEGIN          0x08
#define RAM_END            0x3F

void DS1307_GetTime(byte *hours, byte *minutes, byte *seconds)
//   , ,    BCD.
{
   *hours = I2C_ReadRegister(DS1307,HOURS_REGISTER);
   *minutes = I2C_ReadRegister(DS1307,MINUTES_REGISTER);
   *seconds = I2C_ReadRegister(DS1307,SECONDS_REGISTER);
   if (*hours & 0x40) // 12- :
      *hours &= 0x1F; //   5  ( pm   0x20)
   else
      *hours &= 0x3F; // 24- :   6 
}

void DS1307_GetDate(byte *months, byte *days, byte *years)
//   , ,    BCD.
{
   *months = I2C_ReadRegister(DS1307,MONTHS_REGISTER);
   *days = I2C_ReadRegister(DS1307,DAYS_REGISTER);
   *years = I2C_ReadRegister(DS1307,YEARS_REGISTER);
}

void SetTimeDate()
//      .
{
   I2C_WriteRegister(DS1307,MONTHS_REGISTER, 0x08);
   I2C_WriteRegister(DS1307,DAYS_REGISTER, 0x31);
   I2C_WriteRegister(DS1307,YEARS_REGISTER, 0x13);
   I2C_WriteRegister(DS1307,HOURS_REGISTER, 0x08+0x40); //  0x40  PM
   I2C_WriteRegister(DS1307,MINUTES_REGISTER, 0x51);
   I2C_WriteRegister(DS1307,SECONDS_REGISTER, 0x00);
}
