//-----------------------------------------------------------------------------
// i2c01:     ATmega328  DS1307 RTC
//
// : Bruce E. Hall < bhall66@gmail.com >
// : w8bh.net
// : 1.1
// : 7 Sep 2013
//  :  ATmega328P
//  : C,    Atmel Studio 6
//   : 1386     -O1
//
//  : 8     65  ,  SPI,
//      8.
#include "settings.h"
#include "HD44780.h"
#include "TWI.h"
#include "DS1307.h"
#include "misc.h"

// ---------------------------------------------------------------------------
//  

void ShowDevices()
//   I2C      .
{
   LCD_Line(1); LCD_String("Found:");
   byte addr = 1;
   while (addr>0)
   {
      LCD_Char(' ');
      addr = I2C_FindDevice(addr);
      if (addr>0) LCD_Hex(addr++);
   }
}

void LCD_TwoDigits(byte data)
//    WriteDate().
//    2    BCD.
//      LCD    .
{
   byte temp = data>>4;
   LCD_Char(temp+'0');
   data &= 0x0F;
   LCD_Char(data+'0');
}

void WriteDate()
{
   byte months, days, years;
   DS1307_GetDate(&months,&days,&years);
   LCD_TwoDigits(months);
   LCD_Char('/');
   LCD_TwoDigits(days);
   LCD_Char('/');
   LCD_TwoDigits(years);
}

void WriteTime()
{
   byte hours, minutes, seconds;
   DS1307_GetTime(&hours,&minutes,&seconds);
   LCD_TwoDigits(hours);
   LCD_Char(':');
   LCD_TwoDigits(minutes);
   LCD_Char(':');
   LCD_TwoDigits(seconds);
}

void LCD_TimeDate()
{
   LCD_Line(0); WriteTime();
   LCD_Line(1); WriteDate();
}

// ---------------------------------------------------------------------------
//   .
void MainLoop()
{
   while(1)
   {
      LCD_TimeDate();   //   LCD   
      msDelay(1000);    //    1 
   }
}

// ---------------------------------------------------------------------------
//  :   main.
int main(void)
{
   InitAVR();     //   GPIO 
   LCD_Init();    //   HD44780  LCD
   I2C_Init();    //   I2C (    )
   LCD_String("Ready.");
   ShowDevices(); // ,   I2C  
   msDelay(4000);
   LCD_Clear();
   MainLoop();    //  
}
